SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

!Number methodsFor: '*ejerciciospoo-measure' stamp: 'TomasRodriguez 5/27/2013 18:07'!
divide: aMeasure

	^ Measure amount: (aMeasure amount / self)  unit: aMeasure unit! !

!Number methodsFor: '*ejerciciospoo-measure' stamp: 'TomasRodriguez 5/27/2013 18:06'!
multiply: aMeasure

	^ Measure amount: (aMeasure amount * self)  unit: aMeasure unit! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'TomasRodriguez 5/25/2013 08:38'!
canNotConvertMeasurementException
	
	^ Error
	"self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'"! !

!MeasureTest methodsFor: 'temperature units' stamp: 'TomasRodriguez 5/27/2013 14:27'!
celsius
	
	^TemperatureUnit name: 'celsius' convertionToBase: [:aValue | aValue + 273] convertionFromBase:  [:aValue | aValue - 273].! !

!MeasureTest methodsFor: 'distance units' stamp: 'TomasRodriguez 5/24/2013 18:59'!
centimeter
	
	^ DistanceUnit name: 'centimeter' convertionToBase: [:aValue | aValue / 100] convertionFromBase:  [:aValue | aValue * 100].! !

!MeasureTest methodsFor: 'time units' stamp: 'TomasRodriguez 5/24/2013 19:11'!
day
	
	^ TimeUnit name: 'day' convertionToBase: [:aValue | aValue * 86400] convertionFromBase:  [:aValue | aValue / 86400].! !

!MeasureTest methodsFor: 'distance units' stamp: 'TomasRodriguez 5/24/2013 19:10'!
decameter
	
	^ DistanceUnit name: 'decameter' convertionToBase: [:aValue | aValue * 10] convertionFromBase:  [:aValue | aValue / 10].! !

!MeasureTest methodsFor: 'distance units' stamp: 'TomasRodriguez 5/24/2013 19:09'!
decimeter
	
	^ DistanceUnit name: 'decimeter' convertionToBase: [:aValue | aValue / 10] convertionFromBase:  [:aValue | aValue * 10].! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/25/2013 11:37'!
eightCubicMeters

	^ Measure amount: 8 unit: (self meter * self meter * self meter)! !

!MeasureTest methodsFor: 'temperature units' stamp: 'TomasRodriguez 5/27/2013 14:31'!
fahrenheit
	
	^TemperatureUnit name: 'fahrenheit' convertionToBase: [:aValue | (((aValue - 32) / 1.8000) + 273) ] 
		convertionFromBase: [:aValue | ((aValue - 273) * 1.8000) + 32 ].! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/27/2013 11:11'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^ initialSpeed + (anAcceleration * aTimePeriod )
	"^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'"! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/25/2013 11:36'!
fourSquaredMeters

	^ Measure amount: 4 unit: (self meter * self meter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/27/2013 11:09'!
halfMeterBySecond
	
	^ Measure amount: (1/2) unit: (self meter / self second )! !

!MeasureTest methodsFor: 'distance units' stamp: 'TomasRodriguez 5/24/2013 19:10'!
hectometer
	
	^ DistanceUnit name: 'hectometer' convertionToBase: [:aValue | aValue * 100] convertionFromBase:  [:aValue | aValue / 100].! !

!MeasureTest methodsFor: 'time units' stamp: 'TomasRodriguez 5/24/2013 19:12'!
hour
	
	^ TimeUnit name: 'hour' convertionToBase: [:aValue | aValue * 3600] convertionFromBase:  [:aValue | aValue /3600].! !

!MeasureTest methodsFor: 'temperature units' stamp: 'TomasRodriguez 5/27/2013 14:27'!
kelvin
	
	^TemperatureUnit name: 'kelvin' convertionToBase: [:aValue | aValue] convertionFromBase: [:aValue | aValue].! !

!MeasureTest methodsFor: 'distance units' stamp: 'TomasRodriguez 5/24/2013 19:11'!
kilometer
	
	^ DistanceUnit name: 'kilometer' convertionToBase: [:aValue | aValue * 1000] convertionFromBase:  [:aValue | aValue / 1000 ].! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'TomasRodriguez 5/24/2013 18:51'!
meter

	^ DistanceUnit name: 'meter' convertionToBase: [:aValue | aValue * 1] convertionFromBase:  [:aValue | aValue * 1].! !

!MeasureTest methodsFor: 'distance units' stamp: 'TomasRodriguez 5/24/2013 19:09'!
millimeter
	
	^ DistanceUnit name: 'millimeter' convertionToBase: [:aValue | aValue / 1000] convertionFromBase:  [:aValue | aValue * 1000].! !

!MeasureTest methodsFor: 'distance measures' stamp: 'TomasRodriguez 5/27/2013 13:22'!
minusOneMeter 
	
	^ Measure amount: -1 unit: self meter! !

!MeasureTest methodsFor: 'time units' stamp: 'TomasRodriguez 5/24/2013 19:03'!
minute
	
	^ TimeUnit name: 'minute' convertionToBase: [:aValue | aValue * 60] convertionFromBase:  [:aValue | aValue / 60].! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'TomasRodriguez 5/24/2013 18:29'!
oneCelsius
	
	^ Measure amount: 1 unit: (self celsius)! !

!MeasureTest methodsFor: 'distance measures' stamp: 'TomasRodriguez 5/27/2013 13:23'!
oneCentimeter
	
	^ Measure amount: 1 unit: self centimeter ! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 19:42'!
oneDay
	
	^ Measure amount: 1 unit: (self day)! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 19:42'!
oneHour
	
	^ Measure amount: 1 unit: (self hour)! !

!MeasureTest methodsFor: 'distance measures' stamp: 'TomasRodriguez 5/24/2013 18:53'!
oneHundredCentimeters
	
	^ Measure amount: 100 unit: (self centimeter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/27/2013 13:15'!
oneHundredTwentyOneMetersPerSecond

	^ Measure amount: 121 unit: (self meter / self second )! !

!MeasureTest methodsFor: 'distance measures' stamp: 'TomasRodriguez 5/24/2013 18:09'!
oneMeter
	
	^ Measure amount: 1 unit: (self meter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/27/2013 11:11'!
oneMeterPerSecond

	^ Measure amount: 1 unit: (self meter / self second )! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 19:00'!
oneMinute
	
	^ Measure amount: 1 unit: (self minute)! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 18:24'!
oneSecond

	^ Measure amount: 1 unit: (self second)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/25/2013 11:36'!
oneSquaredMeter

	^ Measure amount: 1 unit: (self meter * self meter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/25/2013 11:37'!
oneSquaredSecond

	^ Measure amount: 1 unit: (self second  * self second )! !

!MeasureTest methodsFor: 'time units' stamp: 'TomasRodriguez 5/24/2013 18:51'!
second
	
	^ TimeUnit name: 'second' convertionToBase: [:aValue | aValue * 1] convertionFromBase:  [:aValue | aValue * 1].! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 19:42'!
sixtyMinutes
	
	^ Measure amount: 60 unit: (self minute )! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 21:26'!
sixtyOneSeconds
	
	^ Measure amount: 61 unit: (self second )! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 18:44'!
sixtySeconds
	
	^ Measure amount: 60 unit: (self second)! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'TomasRodriguez 5/24/2013 19:10'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'TomasRodriguez 5/24/2013 19:18'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'TomasRodriguez 5/25/2013 10:56'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'TomasRodriguez 5/27/2013 11:08'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self halfMeterBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'TomasRodriguez 5/24/2013 19:04'!
thirtyTwoFahrenheits
	
	^ Measure amount: 32 unit: (self fahrenheit)! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 19:42'!
twentyFourHours
	
	^ Measure amount: 24 unit: (self hour)! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'TomasRodriguez 5/24/2013 21:26'!
twoCelsius
	
	^ Measure amount: 2 unit: (self celsius )! !

!MeasureTest methodsFor: 'distance measures' stamp: 'TomasRodriguez 5/24/2013 19:00'!
twoHundredCentimeters
	
	^ Measure amount: 200 unit: (self centimeter)! !

!MeasureTest methodsFor: 'distance measures' stamp: 'TomasRodriguez 5/24/2013 18:43'!
twoMeters
	
	^ Measure amount: 2 unit: (self meter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/27/2013 11:03'!
twoMetersBySecond

	^ Measure amount: 2 unit: (self meter / self second )! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/27/2013 11:12'!
twoMetersPerSquaredSecond

	^ Measure amount: 2 unit: (self meter / (self second * self second))! !

!MeasureTest methodsFor: 'compound measures' stamp: 'TomasRodriguez 5/25/2013 11:38'!
twoMetersTimesSecond

	^ Measure amount: 2 unit: (self second  * self second )! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/24/2013 21:26'!
twoSeconds
	
	^ Measure amount: 2 unit: (self second)! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'TomasRodriguez 5/27/2013 14:02'!
zeroCelsius
	
	^ ZeroMeasure amount: 0 unit: (self celsius)! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'TomasRodriguez 5/27/2013 14:15'!
zeroKelvin
	
	^ ZeroMeasure amount: 0 unit: self kelvin ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'TomasRodriguez 5/27/2013 14:01'!
zeroMeters

	^ ZeroMeasure amount: 0 unit: (self meter)! !

!MeasureTest methodsFor: 'time measures' stamp: 'TomasRodriguez 5/27/2013 14:02'!
zeroSeconds
	
	^ ZeroMeasure amount: 0 unit: (self second )! !

Object subclass: #CompoundUnit
	instanceVariableNames: 'numerator denominator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundUnit class methodsFor: 'class initialization' stamp: 'TomasRodriguez 5/27/2013 13:12'!
formedBy: aDistanceUnit dividedBy: otherDistanceUnit  
	
	^ self new formedBy: aDistanceUnit  dividedBy: otherDistanceUnit! !

!CompoundUnit class methodsFor: 'class initialization' stamp: 'TomasRodriguez 5/27/2013 13:09'!
formedBy: aDistanceUnit multipliedBy: otherDistanceUnit
	
	^ self new formedBy: aDistanceUnit  multipliedBy: otherDistanceUnit ! !

!CompoundUnit methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/27/2013 18:15'!
* anUnit 
	
	numerator add: anUnit ! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/27/2013 18:20'!
amount: anAmount
	^ Measure amount: anAmount unit: self! !

!CompoundUnit methodsFor: 'converting' stamp: 'TomasRodriguez 5/27/2013 13:11'!
conversionToBase
	
	^ [ :aValue | aValue ]! !

!CompoundUnit methodsFor: 'converting' stamp: 'TomasRodriguez 5/27/2013 13:14'!
convertionFormulaToConvertFromBase: aMeasure 
	
	^ [ :aValue | aValue ]! !

!CompoundUnit methodsFor: 'accessing' stamp: 'TomasRodriguez 5/27/2013 18:18'!
formedBy: aDistanceUnit dividedBy: otherDistanceUnit 
	
	(aDistanceUnit = otherDistanceUnit) ifTrue: [^ NullUnit new] ifFalse: [
		numerator add: aDistanceUnit .
		denominator add: otherDistanceUnit ]! !

!CompoundUnit methodsFor: 'accessing' stamp: 'TomasRodriguez 5/27/2013 13:10'!
formedBy: aDistanceUnit multipliedBy: otherDistanceUnit 
	
	numerator add: aDistanceUnit .
	denominator add: otherDistanceUnit ! !

!CompoundUnit methodsFor: 'initialize-release' stamp: 'TomasRodriguez 5/27/2013 13:10'!
initialize 

	numerator := Set new.
	denominator := Set new.! !

Object subclass: #Measure
	instanceVariableNames: 'amount unit amountConvertedToBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'class initialization' stamp: 'TomasRodriguez 5/24/2013 18:20'!
amount: anAmount unit: anUnit 
	
	^ self new amount: anAmount unit: anUnit ! !

!Measure class methodsFor: 'error handling' stamp: 'TomasRodriguez 5/25/2013 08:32'!
canNotConvertMeasurementMessage

	^ 'No se puede convertir'! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/27/2013 18:08'!
* anObject 
	
	^ anObject multiply: self
	! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/24/2013 21:25'!
+ aMeasure 
	
	| adderConverted |
	adderConverted := aMeasure convertTo: (self unit).
	^ Measure amount: (self amount + adderConverted amount) unit: unit! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/24/2013 21:25'!
- aMeasure 
	
	| adderConverted |
	adderConverted := aMeasure convertTo: (self unit).
	^ Measure amount: (self amount - adderConverted amount) unit: unit! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/27/2013 18:08'!
/ anObject 
	
	^ anObject divide: self! !

!Measure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 13:26'!
< aMeasure 

	^ amountConvertedToBase < aMeasure amountConvertedToBase ! !

!Measure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 13:27'!
<= aMeasure 

	^ amountConvertedToBase <= aMeasure amountConvertedToBase ! !

!Measure methodsFor: 'measure management' stamp: 'FedericoMendez 5/27/2013 16:26'!
= anObject
	
	^ anObject isKindOf: self! !

!Measure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 13:27'!
> aMeasure 

	^ amountConvertedToBase > aMeasure amountConvertedToBase ! !

!Measure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 13:27'!
>= aMeasure 

	^ amountConvertedToBase >= aMeasure amountConvertedToBase ! !

!Measure methodsFor: 'measure management' stamp: 'TomasRodriguez 5/24/2013 18:44'!
amount

	^ amount! !

!Measure methodsFor: 'measure management' stamp: 'TomasRodriguez 5/25/2013 08:53'!
amount: anAmount unit: anUnit 
	
	amount := anAmount .
	unit := anUnit .
	amountConvertedToBase := unit conversionToBase value: amount! !

!Measure methodsFor: 'measure management' stamp: 'TomasRodriguez 5/25/2013 08:54'!
amountConvertedToBase 

	^ amountConvertedToBase ! !

!Measure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 13:47'!
between: aMeasure  and: otherMeasure

	^amountConvertedToBase between: (aMeasure amountConvertedToBase)  and: (otherMeasure amountConvertedToBase )! !

!Measure methodsFor: 'converting' stamp: 'TomasRodriguez 5/25/2013 08:56'!
convertTo: anUnit 	
	
	| convertedAmount |
	convertedAmount := (anUnit convertionFormulaToConvertFromBase: self) value: amountConvertedToBase.
	^ Measure amount: convertedAmount unit: anUnit ! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/27/2013 18:17'!
divide: aMeasure 
	
	| dividedAmount dividedUnit |
	dividedAmount := aMeasure amount / amount.
	dividedUnit := aMeasure unit / unit.
	^ dividedUnit amount: dividedAmount 
	"(dividedUnit class = NullUnit class) ifTrue: [^dividedAmount ] ifFalse: [^ Measure amount: dividedAmount unit: dividedUnit]"! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/25/2013 11:42'!
divideForAMagnitude: aMagnitude 
	
	^ Measure amount: (self amount / aMagnitude ) unit: unit! !

!Measure methodsFor: 'measure management' stamp: 'TomasRodriguez 5/24/2013 21:20'!
hash

	^1! !

!Measure methodsFor: 'comparing' stamp: 'FedericoMendez 5/27/2013 17:03'!
isKindOf: aMeasure 

	^ (aMeasure unit class = unit class) and: (amountConvertedToBase = (aMeasure amountConvertedToBase))! !

!Measure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 13:40'!
max: aMeasure 

	(amountConvertedToBase > aMeasure amountConvertedToBase) ifTrue: [^ self] ifFalse: [^ aMeasure ]! !

!Measure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 13:40'!
min: aMeasure 

	(amountConvertedToBase < aMeasure amountConvertedToBase) ifTrue: [^ self] ifFalse: [^ aMeasure ]! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/25/2013 11:32'!
multiply: aMeasure 
	
	| multipliedAmount multipliedUnit |
	multipliedAmount := aMeasure amount * amount.
	multipliedUnit := aMeasure unit * unit.
	^ Measure amount: multipliedAmount unit: multipliedUnit! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/25/2013 11:26'!
multiplyForAMagnitude: aMagnitude 
	
	^ Measure amount: (self amount * aMagnitude ) unit: unit! !

!Measure methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/24/2013 21:27'!
negated
	
	^ Measure amount: (amount * -1) unit: unit! !

!Measure methodsFor: 'printing' stamp: 'TomasRodriguez 5/24/2013 19:18'!
printString

	^ amount printString , ' ', ((unit name = 'celsius') ifTrue: [unit name] ifFalse:  [unit name asPluralBasedOn: amount])! !

!Measure methodsFor: 'measure management' stamp: 'TomasRodriguez 5/27/2013 13:53'!
to: stop 

	|step|
	step := Measure amount: 1 unit: unit .
	
	^ self to: stop by: step .! !

!Measure methodsFor: 'measure management' stamp: 'TomasRodriguez 5/27/2013 13:53'!
to: stop by: step

	^ MeasureInterval from: self to: stop by: step ! !

!Measure methodsFor: 'accessing' stamp: 'TomasRodriguez 5/24/2013 19:07'!
unit

	^ unit! !

Measure subclass: #ZeroMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!ZeroMeasure methodsFor: 'comparing' stamp: 'TomasRodriguez 5/27/2013 14:32'!
isKindOf: aMeasure 

	^ amountConvertedToBase = (aMeasure amountConvertedToBase)! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'start stop by'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/27/2013 13:55'!
from: startMeasure to: stopMeasure by: stepMeasure 
	^self new
		setFrom: startMeasure
		to: stopMeasure
		by: stepMeasure! !

!MeasureInterval methodsFor: 'tracing' stamp: 'TomasRodriguez 5/27/2013 13:58'!
do: aBlock

	| temp index size |
	
	index := 0 .
	size := self size .
	
	[index < size]
		whileTrue: 	[	
						temp := start + (by * index) .
						aBlock value: temp .
						index := index + 1 .
					]! !

!MeasureInterval methodsFor: 'accessing' stamp: 'TomasRodriguez 5/27/2013 13:56'!
first

	^ start! !

!MeasureInterval methodsFor: 'accessing' stamp: 'TomasRodriguez 5/27/2013 13:56'!
increment

	^ by! !

!MeasureInterval methodsFor: 'accessing' stamp: 'TomasRodriguez 5/27/2013 13:56'!
last

	^ stop! !

!MeasureInterval methodsFor: 'interval management' stamp: 'TomasRodriguez 5/27/2013 13:55'!
setFrom: startMeasure to: stopMeasure by: stepMeasure

	start := startMeasure .
	stop := stopMeasure .
	by := stepMeasure! !

!MeasureInterval methodsFor: 'interval management' stamp: 'TomasRodriguez 5/27/2013 13:57'!
size

	| stopMeasure totalMeasure |
	
	stopMeasure := stop convertTo: by unit .
	totalMeasure := (stopMeasure - start)/by amount .
	
	^ totalMeasure amount + 1 .! !

Object subclass: #NullUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullUnit methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/27/2013 18:19'!
amount: aSmallInteger 
	
	^ aSmallInteger ! !

Object subclass: #Unit
	instanceVariableNames: 'name convertionToBase convertionFromBase base'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #DistanceUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:56'!
convertionFormulaToConvertFromBase: aMeasure

	^ aMeasure unit convertionFormulaToTheDistance: self! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/24/2013 20:41'!
convertionFormulaToTheDistance: anUnit

	^ anUnit conversionFromBase 

	! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:32'!
convertionFormulaToTheTemperature: anUnit

	self exceptionCanNotConvertToMeasure 
	! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 10:54'!
convertionFormulaToTheTime: anUnit

	self exceptionCanNotConvertToMeasure 
	! !

Unit subclass: #TemperatureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:56'!
convertionFormulaToConvertFromBase: aMeasure

	^ aMeasure unit convertionFormulaToTheTemperature: self! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:33'!
convertionFormulaToTheDistance: anUnit

	self exceptionCanNotConvertToMeasure ! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/24/2013 20:42'!
convertionFormulaToTheTemperature: anUnit

	^ anUnit conversionFromBase ! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:33'!
convertionFormulaToTheTime: anUnit

	self exceptionCanNotConvertToMeasure ! !

Unit subclass: #TimeUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:56'!
convertionFormulaToConvertFromBase: aMeasure

	^ aMeasure unit convertionFormulaToTheTime: self! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:33'!
convertionFormulaToTheDistance: anUnit

	self exceptionCanNotConvertToMeasure ! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/25/2013 08:33'!
convertionFormulaToTheTemperature: anUnit

	self exceptionCanNotConvertToMeasure ! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 5/24/2013 20:42'!
convertionFormulaToTheTime: anUnit

	^ anUnit conversionFromBase ! !

!Unit class methodsFor: 'class initialization' stamp: 'TomasRodriguez 5/24/2013 18:49'!
name: aName convertionToBase: aBlockClosure convertionFromBase: otherBlockClosure 

	^ self new name: aName convertionToBase: aBlockClosure convertionFromBase: otherBlockClosure ! !

!Unit methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/27/2013 13:09'!
* anUnit 
	
	^ CompoundUnit formedBy: self multipliedBy: anUnit .
	"^ Unit name: (name,'x',anUnit name ) convertionToBase: [ :aValue | aValue ] convertionFromBase: [ :aValue | aValue ]"! !

!Unit methodsFor: 'arithmetic' stamp: 'TomasRodriguez 5/27/2013 13:11'!
/ anUnit 
	
	^ CompoundUnit formedBy: self dividedBy: anUnit .
	
	"| numerador denominador unitResult |
	numerador := self.
	denominador := anUnit .
	unitResult := Unit name: (name,'/',anUnit name ) convertionToBase: [ :aValue | aValue ] convertionFromBase: [ :aValue | aValue ].
	(numerador = denominador ) ifTrue: [^NullUnit] ifFalse: [^unitResult]"! !

!Unit methodsFor: 'comparing' stamp: 'TomasRodriguez 5/24/2013 19:28'!
= anUnit

	^ self class = anUnit class and: (self name = anUnit name)! !

!Unit methodsFor: 'others' stamp: 'TomasRodriguez 5/27/2013 13:24'!
adaptToNumber: aSmallInteger andSend: aByteSymbol 
	
	^ Measure amount: aSmallInteger unit: self! !

!Unit methodsFor: 'accessing' stamp: 'TomasRodriguez 5/24/2013 19:38'!
conversionFromBase
	
	^ convertionFromBase ! !

!Unit methodsFor: 'accessing' stamp: 'TomasRodriguez 5/24/2013 18:58'!
conversionToBase
	
	^ convertionToBase ! !

!Unit methodsFor: 'error handling' stamp: 'TomasRodriguez 5/25/2013 10:59'!
exceptionCanNotConvertToMeasure

	self error: Measure canNotConvertMeasurementMessage! !

!Unit methodsFor: 'unit management' stamp: 'TomasRodriguez 5/24/2013 18:49'!
name: aName convertionToBase: aBlockClosure convertionFromBase: otherBlockClosure 
	
	name := aName .
	convertionToBase := aBlockClosure .
	convertionFromBase := otherBlockClosure ! !

!Unit methodsFor: 'printing' stamp: 'TomasRodriguez 5/24/2013 19:08'!
printString 

	^ name! !
